﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO.Ports;
using System.Text.RegularExpressions;




using System.Threading;


namespace Sharp
{
    
    public partial class Form1 : Form
    {
        string RxString;
        int oldy = 0;
        int oldx = 0;

        public Form1()
        {
            InitializeComponent();
        }

        public Bitmap RotateImage(Image image, PointF offset, float angle)
        {
            if (image == null)
                throw new ArgumentNullException("image");     /* výnimka pre nenačítaný obrázok*/

            //nový prázdny obrázok do ktorého sa vloží otočený
            Bitmap rotatedBmp = new Bitmap(image.Width, image.Height);
            rotatedBmp.SetResolution(image.HorizontalResolution, image.VerticalResolution);

            //vytvorenie objektu graphics z prázdneho obrázku
            Graphics g = Graphics.FromImage(rotatedBmp);

            //presun bodu rotácie do stredu obrázku
            g.TranslateTransform(offset.X, offset.Y);

            //samotné otočenie
            g.RotateTransform(angle);

            //presun obrázku späť
            g.TranslateTransform(-offset.X, -offset.Y);

            //vkreslenie otoceného obrázk do prázdneho objektu graphics
            g.DrawImage(image, new PointF(0, 0));

            return rotatedBmp;   /* vráť otočený obrázok*/
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            foreach (string s in SerialPort.GetPortNames())    /* pre každý nájdený port  */
            {
                comboBox1.Items.Add(s);     /*pridá jeho názov do comboBox-u   */
            }
            try
            {
                Bitmap image = (Bitmap)Image.FromFile("Pics/Kompas.bmp");    /*načítanie obrázku ružice kompasu   */
                pictureBox1.Image = (Bitmap)image.Clone();
                Bitmap image2 = (Bitmap)Image.FromFile("Pics/Smer.bmp");    /*načítanie obrázku šípky pre smer natočenia senzoru*/
                pictureBox2.Image = (Bitmap)image2.Clone();
            }
            catch (Exception ex)
            {
                MessageBox.Show("Nebol nájdený obrázok kompasu. (Cesta: Pics/Kompas.bmp)", "Chýbajúci obrázok", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            try
            {
                Bitmap image = (Bitmap)Image.FromFile("Pics/Kompas.bmp");
                pictureBox1.Image = RotateImage(image, new PointF(200, 200), 0);
                if (textBox1.Visible == true)
                {
                    label1.Text = "Uhol: 0°";
                    textBox1.Text = "0,0,0";
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show("Nebol nájdený obrázok kompasu. (Cesta: Pics/Kompas.bmp)", "Chýbajúci obrázok", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            serialPort1.PortName = comboBox1.Text;
            

                serialPort1.BaudRate = 9600;
                try
                {
                    serialPort1.Open();
                    textBox1.Visible = true;
                    label1.Text = "Port " + comboBox1.Text + " je pripravený prijímať dáta.";
                    comboBox1.Visible = false;
                    label2.Visible = false;
                    label1.Visible = true;
            }
                catch (Exception ex)
                {
                label1.Visible = true;
                label1.Text = "Port " + comboBox1.Text + " používa iná aplikácia.";
                }       
        }

        private void button2_Click(object sender, EventArgs e)
        {
            textBox1.Visible = false;
            label1.Visible = false;
            comboBox1.Visible = true;
            label2.Visible = true;
            serialPort1.Close();
            textBox1.Text = "0,0,0";
        }


        private void DisplayText(object sender, EventArgs e)
        {
            label1.Text = "Prichádzajúce dáta:";
            textBox1.Text = RxString;
        }

       
        private void serialPort1_DataReceived_1(object sender, SerialDataReceivedEventArgs e)
        {
            RxString = serialPort1.ReadLine();
            this.Invoke(new EventHandler(DisplayText));
        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {
            string retazec = textBox1.Text;     /* uloženie načítaných dát zobrazených v textBox-e do premennej  */
            string vzorka = ",";     /* kľúčový znak pre rozdelenie regulárneho výrazu  */

            string[] vysledok = Regex.Split(retazec, vzorka);     /*  uloženie rozdeleného reťazca do poľa reťazcov  */
            double x = Convert.ToDouble(vysledok[0])/1100*100;   /* konverzia dátového typu a uloženie do premennej x  */
            double y = Convert.ToDouble(vysledok[1])/1100*100;   /* konverzia dátového typu a uloženie do premennej y  */
            double z = Convert.ToDouble(vysledok[2])/980*100;   /* konverzia dátového typu a uloženie do premennej z  */

             z = 360 + z;

            double deklinacia = 4.1833;     /* uváženie magnetickej deklinácie na základe polohy (http://www.magnetic-declination.com/)*/
            double uhol = Math.Atan2(x, y) * 180 / Math.PI;    /* výpočet uhla zo súradníc a prepočet z radiánov na stupne */


            uhol = uhol + deklinacia;   /* pričítanie zistenej magnetickej deklinácie */


            if (uhol < 0)
                uhol += 360;      /* úprava uhla na rozmedzie 0-360° */

            if (uhol > 360)
                uhol -= 360;

            uhol = Math.Truncate(uhol * 100) / 100;   /* orezanie vypočítanej hodnoty na 2 desatinné miesta */

            uhol = 2 * (uhol - 100) + 25;    /* linearizácia vypočítaného uhla pre aproximovaný uhol natočenia obrázku */


            if (uhol < 0)
                uhol += 360;

            if (uhol > 360)
                uhol -= 360;


            label1.Text = "Uhol: " + uhol.ToString() + "°";   /* pomocný výpis vypočítaného celkového uhla natočenia */


            try
            {             
            Bitmap image = (Bitmap)Image.FromFile("Pics/Kompas.bmp");
            pictureBox1.Image = RotateImage(image, new PointF(200, 200), (float)uhol); 
            }
            catch (Exception ex)
            {
                MessageBox.Show("Nebol nájdený obrázok kompasu. (Cesta: Pics/Kompas.bmp)", "Chýbajúci obrázok", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }

            if (z > 20 || z < -20)
            {
                label3.Visible = true;
            }
            else
            {
                label3.Visible = false;
            }
            oldy = Convert.ToInt32(y);
            oldx = Convert.ToInt32(x);

        }

        private void Form1_FormClosing_1(object sender, FormClosingEventArgs e)
        {
            if (serialPort1.IsOpen) serialPort1.Close();
        }

        private void pictureBox1_Click(object sender, EventArgs e)
        {

        }
    }
}
